import 'dotenv/config';
import admin, { ServiceAccount } from 'firebase-admin';
import { FieldValue } from 'firebase-admin/firestore';

import bodyParser from 'body-parser';
import express from 'express';

import * as serviceAccount from './google-services.json';

const { json } = bodyParser;

const RAINFALL_URI = process.env.RAINFALL_URI ?? '';

const app = admin.initializeApp({
  credential: admin.credential.cert(serviceAccount as ServiceAccount),
  databaseURL: process.env.DATABASE_URL ?? '',
});

const db = app.firestore();

type PointData = {
  name: string;
  timestamp: string | null | Date;
  value: number;
};

const globalData: any = {};

(async () => {
  const app = express();

  app.use(
    '/',
    json(),
  );

  app.get('/:name', async (req: any, res: any) => {
    const result = globalData[req.params.name] ?? [];
    res.json(result);
  });

  app.listen(3000);
  console.log(`Listening to port ${3000}`);
})();

// db.collection('colligit').doc('rainfall').onSnapshot(snapshot  => {
//   const data = globalData['rainfall'] ?? [];
//   globalData['rainfall'] = [...data, ...snapshot.data()?.data];
// });

db.collection('colligit').doc('teasense').onSnapshot(snapshot  => {
  const data = globalData['teasense'] ?? [];
  const snapData = snapshot.data();
  if (snapData) {
    globalData['teasense'] = [{
      ...snapData.data[0],
      timestamp: new Date(),
    }];
  }
});
